
/*************************************************
            CREACI DE TAULES
 *************************************************/


DROP TABLE USUARITFC11.votacio CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.votacio(
idVotacio Integer NOT NULL,
titol Varchar2(30) NOT NULL,
descripcio Varchar2(50) NOT NULL,
dataInici Date NOT NULL,
dataFi Date NOT NULL,
dataPublicacio Date NOT NULL,
president Varchar2(30) NOT NULL,
censGlobal Varchar2(30) NOT NULL,
web Varchar2(30),
totalCiutadans Integer,
votsTotals Integer,
percentatgeVotacio Integer,
CONSTRAINT PK_idVotacio PRIMARY KEY (idVotacio)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.opcio CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.opcio(
idOpcio Integer NOT NULL,
idVotacio Integer NOT NULL,
opcio Varchar2(30) NOT NULL,
votsTotals Integer,
percentatge Integer,
CONSTRAINT PK_idOpcio PRIMARY KEY (idOpcio),
CONSTRAINT FK_idVotacio FOREIGN KEY (idVotacio) REFERENCES votacio(idVotacio)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.pais CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.pais(
codPais Varchar2(2) NOT NULL,
pais Varchar2(20) NOT NULL,
CONSTRAINT PK_idPais PRIMARY KEY (codPais)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.regio CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.regio(
idRegio Integer NOT NULL,
regio VARCHAR2(20) NOT NULL,
CONSTRAINT PK_idRegio PRIMARY KEY (idRegio)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.paisRegio CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.paisRegio(
idPaisRegio Integer NOT NULL,
idPais Varchar2(2) NOT NULL,
idRegio Integer NOT NULL,
CONSTRAINT PK_idPaisRegio PRIMARY KEY (idPaisRegio),
CONSTRAINT FK_idPais FOREIGN KEY (idPais) REFERENCES pais(codPais),
CONSTRAINT FK_idRegio FOREIGN KEY (idRegio) REFERENCES regio(idRegio)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.localitat CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.localitat(
idLocalitat Integer NOT NULL,
idRegio Integer NOT NULL,
localitat Varchar2(30) NOT NULL,
CONSTRAINT PK_idLocalitat PRIMARY KEY (idLocalitat),
CONSTRAINT FK_idRegioL FOREIGN KEY (idRegio) REFERENCES regio(idRegio)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.censPais CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.censPais(
idCensPais varchar2(2) NOT NULL,
idVotacio Integer NOT NULL,
idPais Varchar2(2) NOT NULL,
CONSTRAINT PK_idCensPais PRIMARY KEY (idCensPais),
CONSTRAINT FK_idPaisCP FOREIGN KEY (idPais) REFERENCES pais(codPais),
CONSTRAINT FK_idVotacioCP FOREIGN KEY (idVotacio) REFERENCES votacio (idVotacio)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.censRegio CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.censRegio(
idCensRegio Integer NOT NULL,
idRegio Integer NOT NULL,
CONSTRAINT PK_idCensRegio PRIMARY KEY (idCensRegio),
CONSTRAINT FK_idRegioCR FOREIGN KEY (idRegio) REFERENCES regio(idRegio)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.censPaisRegio CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.censPaisRegio(
idCensPaisRegio Integer NOT NULL,
idCensPais Varchar2(2) NOT NULL,
idCensRegio Integer NOT NULL,
idPais Varchar2(2) NOT NULL,
idRegio Integer NOT NULL,
CONSTRAINT PK_idCensPaisRegio PRIMARY KEY (idCensPaisRegio),
CONSTRAINT FK_idCensPais FOREIGN KEY (idCensPais) REFERENCES censPais(idCensPais),
CONSTRAINT FK_idCensRegio FOREIGN KEY (idCensRegio) REFERENCES censRegio(idCensRegio),
CONSTRAINT FK_idPaisCPR FOREIGN KEY (idPais) REFERENCES pais(codPais),
CONSTRAINT FK_idRegioCPR FOREIGN KEY (idRegio) REFERENCES regio(idRegio)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.censLocal CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.censLocal(
idCensLocal Integer NOT NULL,
idCensRegio Integer NOT NULL,
idLocalitat Integer NOT NULL,
CONSTRAINT PK_idCensLocal PRIMARY KEY (idCensLocal),
CONSTRAINT FK_idCensRegioCL FOREIGN KEY (idCensRegio) REFERENCES censRegio(idCensRegio),
CONSTRAINT FK_idLocalitat FOREIGN KEY (idLocalitat) REFERENCES localitat(idLocalitat)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.ciutada CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.ciutada(
codi Varchar2(10) NOT NULL,
edat Date NOT NULL,
CONSTRAINT PK_codi PRIMARY KEY (codi)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.ciutadaOpcio CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.ciutadaOpcio(
idCiutadaOpcio Integer NOT NULL,
idCiutada Varchar2(10) NOT NULL,
idCensLocal Integer NOT NULL,
idOpcio Integer NOT NULL,
CONSTRAINT PK_idCiutadaOpcio PRIMARY KEY (idCiutadaOpcio),
CONSTRAINT FK_idCiutada FOREIGN KEY (idCiutada) REFERENCES ciutada(codi),
CONSTRAINT FK_idCensLocal FOREIGN KEY (idCensLocal) REFERENCES censLocal(idCensLocal),
CONSTRAINT FK_idOpcio FOREIGN KEY (idOpcio) REFERENCES opcio(idOpcio)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.log CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.log(
idLog Integer NOT NULL,
nomProcediment Varchar2(200) NOT NULL,
data Date NOT NULL,
parametreEntrada Varchar2(2000) NOT NULL,
parametreSortida Varchar2(2000) NOT NULL,
CONSTRAINT PK_idLog PRIMARY KEY (idLog)
)
TABLESPACE ts_tfc11;

--TAULA ESTADSTIQUES

DROP TABLE USUARITFC11.votacionsFinalitzades CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.votacionsFinalitzades(
idvotacionsFinalitzades Integer NOT NULL,
idPais Varchar2(2) NOT NULL,
anys Integer NOT NULL,
nombreVotacionsFinalitzades Integer NOT NULL,
CONSTRAINT PK_idVotacionsFinalitzades PRIMARY KEY (idVotacionsFinalitzades)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.mitjaPercentatgeParticipacio CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.mitjaPercentatgeParticipacio(
idMitjaPerPart Integer NOT NULL,
idCens varchar2(2) NOT NULL,
anys Integer NOT NULL,
totalVotacions Integer NOT NULL,
valorMitjaPerPart Integer NOT NULL,
CONSTRAINT PK_idMitjaPerPart PRIMARY KEY (idMitjaPerPart)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.votacionsCens CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.votacionsCens(
idVotacionsCens Integer NOT NULL,
idCens varchar2(2) NOT NULL,
anys Integer NOT NULL,
nombreVotacionsCens Integer NOT NULL,
CONSTRAINT PK_idVotacionsCens PRIMARY KEY (idVotacionsCens)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.votacioMesParticipacio CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.votacioMesParticipacio(
idVotacioMesPart Integer NOT NULL,
anys Integer NOT NULL,
participacio Integer NOT NULL,
votacioMesPart Integer NOT NULL,
CONSTRAINT PK_idVotacioMesPart PRIMARY KEY (idVotacioMesPart)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.localitatMesVots CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.localitatMesVots(
idLocalitatMesVots Integer NOT NULL,
anys Integer NOT NULL,
votsTotals Integer NOT NULL,
localitatMesVots Varchar2(30) NOT NULL,
CONSTRAINT PK_idLocalitatMesVots PRIMARY KEY (idLocalitatMesVots)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.percentatgeCiutadaMaiVot CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.percentatgeCiutadaMaiVot(
idPerCiutadaMaiVot Integer NOT NULL,
anys Integer NOT NULL,
perCiutadaMaiVot Integer NOT NULL,
CONSTRAINT PK_idPerCiutadaMaiVot PRIMARY KEY (idPerCiutadaMaiVot)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.votHistoricaMesParticipacio CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.votHistoricaMesParticipacio(
idVotHisMesPart Integer NOT NULL,
totalVots Integer NOT NULL,
votHisMesPart Varchar2(30) NOT NULL,
CONSTRAINT PK_idVotHisMesPart PRIMARY KEY (idVotHisMesPart)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.votHistoricaDiferencia CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.votHistoricaDiferencia(
idVotHisDif Integer NOT NULL,
votHisDif Varchar2(30) NOT NULL,
maxPercentual Integer NOT NULL,
minPercentual Integer NOT NULL,
difPercentual Integer NOT NULL,
CONSTRAINT PK_idVotHisDif PRIMARY KEY (idVotHisDif)
)
TABLESPACE ts_tfc11;


DROP TABLE USUARITFC11.maxVotacionsPersona CASCADE CONSTRAINTS;

CREATE TABLE USUARITFC11.maxVotacionsPersona(
idMaxVotPersona Integer NOT NULL,
codCiutada Varchar(10) NOT NULL,
numeroMaxVotPersona Integer NOT NULL,
pais varchar2(2) NOT NULL,
CONSTRAINT PK_idMaxVotPersona PRIMARY KEY (idMaxVotPersona)
)
TABLESPACE ts_tfc11;
